/**
 * Copyright (c) 2000-2013 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.meera.dbservice.model;

import com.liferay.portal.kernel.bean.AutoEscape;
import com.liferay.portal.model.BaseModel;
import com.liferay.portal.model.CacheModel;
import com.liferay.portal.service.ServiceContext;

import com.liferay.portlet.expando.model.ExpandoBridge;

import java.io.Serializable;

/**
 * The base model interface for the Student service. Represents a row in the &quot;LS_Student&quot; database table, with each column mapped to a property of this class.
 *
 * <p>
 * This interface and its corresponding implementation {@link com.meera.dbservice.model.impl.StudentModelImpl} exist only as a container for the default property accessors generated by ServiceBuilder. Helper methods and all application logic should be put in {@link com.meera.dbservice.model.impl.StudentImpl}.
 * </p>
 *
 * @author LiferaySavvy
 * @see Student
 * @see com.meera.dbservice.model.impl.StudentImpl
 * @see com.meera.dbservice.model.impl.StudentModelImpl
 * @generated
 */
public interface StudentModel extends BaseModel<Student> {
	/*
	 * NOTE FOR DEVELOPERS:
	 *
	 * Never modify or reference this interface directly. All methods that expect a student model instance should use the {@link Student} interface instead.
	 */

	/**
	 * Returns the primary key of this student.
	 *
	 * @return the primary key of this student
	 */
	public long getPrimaryKey();

	/**
	 * Sets the primary key of this student.
	 *
	 * @param primaryKey the primary key of this student
	 */
	public void setPrimaryKey(long primaryKey);

	/**
	 * Returns the student ID of this student.
	 *
	 * @return the student ID of this student
	 */
	public long getStudentId();

	/**
	 * Sets the student ID of this student.
	 *
	 * @param studentId the student ID of this student
	 */
	public void setStudentId(long studentId);

	/**
	 * Returns the first name of this student.
	 *
	 * @return the first name of this student
	 */
	@AutoEscape
	public String getFirstName();

	/**
	 * Sets the first name of this student.
	 *
	 * @param firstName the first name of this student
	 */
	public void setFirstName(String firstName);

	/**
	 * Returns the last name of this student.
	 *
	 * @return the last name of this student
	 */
	@AutoEscape
	public String getLastName();

	/**
	 * Sets the last name of this student.
	 *
	 * @param lastName the last name of this student
	 */
	public void setLastName(String lastName);

	/**
	 * Returns the student age of this student.
	 *
	 * @return the student age of this student
	 */
	public int getStudentAge();

	/**
	 * Sets the student age of this student.
	 *
	 * @param studentAge the student age of this student
	 */
	public void setStudentAge(int studentAge);

	/**
	 * Returns the student gender of this student.
	 *
	 * @return the student gender of this student
	 */
	public int getStudentGender();

	/**
	 * Sets the student gender of this student.
	 *
	 * @param studentGender the student gender of this student
	 */
	public void setStudentGender(int studentGender);

	/**
	 * Returns the student address of this student.
	 *
	 * @return the student address of this student
	 */
	@AutoEscape
	public String getStudentAddress();

	/**
	 * Sets the student address of this student.
	 *
	 * @param studentAddress the student address of this student
	 */
	public void setStudentAddress(String studentAddress);

	@Override
	public boolean isNew();

	@Override
	public void setNew(boolean n);

	@Override
	public boolean isCachedModel();

	@Override
	public void setCachedModel(boolean cachedModel);

	@Override
	public boolean isEscapedModel();

	@Override
	public Serializable getPrimaryKeyObj();

	@Override
	public void setPrimaryKeyObj(Serializable primaryKeyObj);

	@Override
	public ExpandoBridge getExpandoBridge();

	@Override
	public void setExpandoBridgeAttributes(BaseModel<?> baseModel);

	@Override
	public void setExpandoBridgeAttributes(ExpandoBridge expandoBridge);

	@Override
	public void setExpandoBridgeAttributes(ServiceContext serviceContext);

	@Override
	public Object clone();

	@Override
	public int compareTo(Student student);

	@Override
	public int hashCode();

	@Override
	public CacheModel<Student> toCacheModel();

	@Override
	public Student toEscapedModel();

	@Override
	public Student toUnescapedModel();

	@Override
	public String toString();

	@Override
	public String toXmlString();
}